Subject: bug#73234: 30.0.91; completion-preview-mode doesn't trigger for case-insensitive capf

From: Morgan Willcock <[email-masked]>
Date: Fri, 20 Sep 2024 11:05:40 +0100

Eshel Yaron <[email-masked]> writes:

>>>> I've been trying to think of a way to get it to work without disturbing
>>>> the user interface that already exists.  Maybe it would be possible
>>>> fixup the result in a post-insertion hook if one existed - such a hook
>>>> might be generally useful anyway.
>>>
>>> We have the :exit-function (which your capf can provide as an extra
>>> property alongside the completion table it returns), and indeed you
>>> could use that to "fix" the case of your prefix after completing it.
>>
>> I don't think it is the responsibility of the completion function
>> because it is not the completion function that is modifying the buffer.
>>>
>>> That's an interesting solution, I think.  Or do you have some other kind
>>> of hook in mind?
>>
>> Just a hook that runs after it was completion-preview-mode that inserted
>> a completion.
>
> I'm quite not sure what you mean by responsibility, but in terms of
> functionality, :exit-function is the existing interface for doing
> something after a completion is inserted, and Completion Preview mode
> supports this interface.

The hook would be interface specific because it is the interface which
has modified the case of the completion.

> If :exit-function doesn't work for your use case, please explain why,
> and if there's indeed a need for another hook, it's easy to add one :)

My reasons for not using :exit-function would be:

- If the completion was inserted using a different interface then the
  function would be running unnecessarily.

- For completion functions that I didn't write, :exit-function isn't
  going to be set with the expectation that a particular completion
  interface and case preference is used to insert the candidate.

That said, I am just trying to think of an easy mechanism to preserve
the case of the candidate.  A hook may generally be useful, but adding a
hook does not solve the underlying problem that I am describing here.

Perhaps it is best to just pause for the moment while you get additional
feedback from other users.

Thanks,
Morgan

-- 
Morgan Willcock